# Webbits

[![image](https://img.shields.io/pypi/v/webbits.svg)](https://pypi.python.org/pypi/webbits)

[![Documentation Status](https://readthedocs.org/projects/webbits/badge/?version=latest)](https://webbits.readthedocs.io/en/latest/?version=latest)

Web bits and components for Python.

License:  Free software: Apache Software License 2.0

Work in progress, used internally at [Abilian](<https://abilian.com/>). APIs will change with no warnings.

## Credits

Contains code derived from
[XMLWitch](<https://github.com/galvez/xmlwitch>) (License: BSD License
(BSD), Author: Jonas Galvez).

Inspired by many other projects, including:

### HTML generation in Python

- <https://www.yattag.org/>
- <https://tylerbakke.github.io/MarkupPy/>
- <https://github.com/michaeljones/packed>
- <https://github.com/twidi/mixt/>
- <https://github.com/byteface/domonic>
- <https://pypi.org/project/hyperpython/>
- <https://pypi.org/project/PyHTML/>
- <https://github.com/jviide/htm.py>
- <https://viewdom.readthedocs.io/>
- <https://github.com/pcarbonn/fast_html>
- <https://github.com/sanic-org/html5tagger>

### (Reactive) Components

- [Flet](https://github.com/flet-dev/flet) ★5404 - Flet enables developers to easily build realtime web, mobile and desktop apps in Python. No frontend experience required.
- [Flexx](https://github.com/flexxui/flexx) ★3129 -  Write desktop and web apps in pure Python
- [IDOM](https://github.com/idom-team/idom) ★936 - Create highly interactive web pages purely in Python
- [Reactor](https://github.com/edelvalle/reactor) ★555 -  Phoenix LiveView but for Django
- [Tetra](https://github.com/samwillis/tetra) ★485 - a full stack component framework for Django using Alpine.js
- [Django-Suckpuppet](https://github.com/jonathan-s/django-sockpuppet) ★431 - Build reactive applications with the django tooling you already know and love.
- [Flask-Meld](https://github.com/mikeabrahamsen/Flask-Meld) ★293 - a library to provide server rendered templates over websockets for Flask applications to build reactive components without Javascript.
- [Reacton](https://github.com/widgetti/reacton) ★170 - A pure Python port of React for ipywidgets.
- [Starfyre](https://github.com/sansyrox/starfyre) ★291 - A Python Framework for writing Reactive Front-End Applications.
- [WyC](https://github.com/manatlan/wyc) - Create WebComponent (Custom Element) from a python file 

- https://github.com/edelvalle/reactor/
- https://www.django-unicorn.com/
- Transcrypt / [React in Python](https://leanpub.com/rtp)
- Django-unicorn: https://www.django-unicorn.com/ " Quickly add in simple interactions to regular Django templates without learning a new templating language."
- https://lona-web.org/ "Lona is a web application framework, designed to write responsive web apps in **full** Python."
- http://atlastk.org/ "It's lightweight, available for several languages, and requires only basic knowledge of widespread and easy-to-learn web technologies (no frontend JavaScript required)." (Probably not what we want)
- https://github.com/edelvalle/reactor/
- https://github.com/jpsca/jinjax / https://github.com/jpsca/jinjax-ui

### Other languages

- Pushup: https://news.ycombinator.com/item?id=34246960
- https://hotwire.dev/ "Hotwire is an alternative approach to building modern web applications without using much JavaScript by sending HTML instead of JSON over the wire."
- https://inertiajs.com/ "Inertia.js lets you quickly build modern single-page React, Vue and Svelte apps using classic server-side routing and controllers."
- Hyperapp
- Alpine.js
- https://htmx.org/ + hyperscript
